%define anolis_release 1

%global mutter_api_version 12

Name:          mutter
Version:       44.0
Release:       %{anolis_release}%{?dist}
Summary:       Window and compositing manager based on Clutter

License:       GPLv2+
URL:           http://www.gnome.org
Source0:       http://download.gnome.org/sources/%{name}/44/%{name}-%{version}.tar.xz

# Work-around for OpenJDK's compliance test
Patch0001:        0001-window-actor-Special-case-shaped-Java-windows.patch
Patch0003:        0003-mutter-42.alpha-disable-tegra.patch

BuildRequires: pkgconfig(atk) >= 2.5.3
BuildRequires: pkgconfig(cairo) >= 1.10.0
BuildRequires: pkgconfig(cairo-gobject) >= 1.10.0
BuildRequires: pkgconfig(colord) >= 1.4.5
BuildRequires: pkgconfig(dbus-1)
BuildRequires: pkgconfig(egl)
BuildRequires: pkgconfig(fribidi) >= 1.0.0
BuildRequires: pkgconfig(gbm) >= 21.3
BuildRequires: pkgconfig(gdk-pixbuf-2.0)
BuildRequires: pkgconfig(gi-docgen) >= 2021.1
BuildRequires: pkgconfig(gio-unix-2.0) >= 2.75.1
BuildRequires: pkgconfig(gl)
BuildRequires: pkgconfig(glesv2)
BuildRequires: pkgconfig(glib-2.0) >= 2.75.1
BuildRequires: pkgconfig(gmodule-no-export-2.0) >= 2.75.1
BuildRequires: pkgconfig(gnome-desktop-4)
BuildRequires: pkgconfig(gnome-settings-daemon)
BuildRequires: pkgconfig(gobject-2.0) >= 2.75.1
BuildRequires: pkgconfig(gobject-introspection-1.0)
BuildRequires: pkgconfig(graphene-gobject-1.0) >= 1.10.2
BuildRequires: pkgconfig(gsettings-desktop-schemas) >= 40
BuildRequires: pkgconfig(gtk+-3.0) >= 3.19.8
BuildRequires: pkgconfig(gtk4) >= 4.0.0
BuildRequires: pkgconfig(gudev-1.0) >= 232
BuildRequires: pkgconfig(harfbuzz) >= 2.6
BuildRequires: pkgconfig(ice)
BuildRequires: pkgconfig(json-glib-1.0) >= 0.12.0
BuildRequires: pkgconfig(lcms2) >= 2.6
BuildRequires: pkgconfig(libcanberra) >= 0.26
BuildRequires: pkgconfig(libdrm)
BuildRequires: pkgconfig(libinput) >= 1.19.0
BuildRequires: pkgconfig(libpipewire-0.3) >= 0.3.33
BuildRequires: pkgconfig(libstartup-notification-1.0) >= 0.7
BuildRequires: pkgconfig(libsystemd)
BuildRequires: pkgconfig(libudev) >= 228
BuildRequires: pkgconfig(libwacom) >= 0.13
BuildRequires: pkgconfig(pango) >= 1.46.0
BuildRequires: pkgconfig(pangocairo) >= 1.20
BuildRequires: pkgconfig(pangoft2)
BuildRequires: pkgconfig(sm)
BuildRequires: pkgconfig(sysprof-4)
BuildRequires: pkgconfig(sysprof-capture-4)
BuildRequires: pkgconfig(udev)
BuildRequires: pkgconfig(wayland-client) >= 1.21
BuildRequires: pkgconfig(wayland-egl)
BuildRequires: pkgconfig(wayland-eglstream-protocols)
BuildRequires: pkgconfig(wayland-protocols) >= 1.31
BuildRequires: pkgconfig(wayland-server) >= 1.21
BuildRequires: pkgconfig(x11) >= 1.7.0
BuildRequires: pkgconfig(x11-xcb)
BuildRequires: pkgconfig(xau)
BuildRequires: pkgconfig(xcb-randr)
BuildRequires: pkgconfig(xcb-res)
BuildRequires: pkgconfig(xcomposite) >= 0.4
BuildRequires: pkgconfig(xcursor)
BuildRequires: pkgconfig(xdamage)
BuildRequires: pkgconfig(xext)
BuildRequires: pkgconfig(xfixes) >= 6
BuildRequires: pkgconfig(xi) >= 1.7.4
BuildRequires: pkgconfig(xinerama)
BuildRequires: pkgconfig(xkbcommon) >= 0.4.3
BuildRequires: pkgconfig(xkbcommon-x11)
BuildRequires: pkgconfig(xkbfile)
BuildRequires: pkgconfig(xkeyboard-config)
BuildRequires: pkgconfig(xrandr) >= 1.5.0
BuildRequires: pkgconfig(xrender)
BuildRequires: pkgconfig(xtst)
BuildRequires: pkgconfig(xwayland)
BuildRequires: /usr/bin/xvfb-run
BuildRequires: /usr/bin/cvt
# For /usr/include/EGL/eglmesaext.h
BuildRequires: mesa-libEGL-devel
BuildRequires: meson >= 0.58.0
BuildRequires: gettext

Requires: control-center-filesystem
Requires: gsettings-desktop-schemas >= 40
Requires: gnome-settings-daemon
Requires: json-glib >= 0.12.0
Requires: libinput >= 1.19.0
Requires: pipewire >= 0.3.33
Requires: startup-notification
Requires: dbus

Recommends: mesa-dri-drivers

Provides: firstboot(windowmanager) = mutter

# Cogl and Clutter were forked at these versions, but have diverged
# significantly since then.
Provides: bundled(cogl) = 1.22.0
Provides: bundled(clutter) = 1.26.0

%description
Mutter is a window and compositing manager that displays and manages
your desktop via OpenGL. Mutter combines a sophisticated display engine
using the Clutter toolkit with solid window-management logic inherited
from the Metacity window manager.

While Mutter can be used stand-alone, it is primarily intended to be
used as the display core of a larger system such as GNOME Shell. For
this reason, Mutter is very extensible via plugins, which are used both
to add fancy visual effects and to rework the window management
behaviors to meet the needs of the environment.

%package devel
Summary: Development package for %{name}
Requires: %{name} = %{version}-%{release}
# for EGL/eglmesaext.h that's included from public cogl-egl-defines.h header
Requires: mesa-libEGL-devel

%description devel
Header files and libraries for developing Mutter plugins. Also includes
utilities for testing Metacity/Mutter themes.

%package  tests
Summary:  Tests for the %{name} package
Requires: %{name} = %{version}-%{release}

%description tests
The %{name}-tests package contains tests that can be used to verify
the functionality of the installed %{name} package.

%package doc
Summary:        Documentation files for %{name}
Requires:       %{name} = %{EVR}
BuildArch:      noarch

%description    doc
The %{name}-doc package contains documentation files for %{name}.

%prep
%autosetup -n %{name}-%{version} -p1

%build
%meson -Degl_device=true -Dwayland_eglstream=true
%meson_build

%install
%meson_install

%generate_compatibility_deps

%find_lang %{name}

%files -f %{name}.lang
%license COPYING
%dir %{abidir}
%{_bindir}/mutter
%{_libdir}/lib*.so.*
%{abidir}/lib*.dump
%{_libdir}/mutter-%{mutter_api_version}/
%{_libexecdir}/mutter-restart-helper
%{_libexecdir}/mutter-x11-frames
%{_datadir}/GConf/gsettings/mutter-schemas.convert
%{_datadir}/glib-2.0/schemas/org.gnome.mutter.gschema.xml
%{_datadir}/glib-2.0/schemas/org.gnome.mutter.wayland.gschema.xml
%{_datadir}/gnome-control-center/keybindings/50-mutter-*.xml
%{_mandir}/man1/mutter.1*
%{_udevrulesdir}/61-mutter.rules

%files devel
%{_includedir}/*
%{_libdir}/lib*.so
%{_libdir}/pkgconfig/*

%files tests
%{_libexecdir}/installed-tests/mutter-%{mutter_api_version}
%{_datadir}/installed-tests/mutter-%{mutter_api_version}
%{_datadir}/mutter-%{mutter_api_version}/tests

%files doc
%doc NEWS README.md HACKING.md

%changelog
* Fri Mar 31 2023 Funda Wang <fundawang@yeah.net> - 44.0-1
- New version 44.0

* Mon Mar 20 2023 yuanhui <yuanhui@linux.alibaba.com> - 44~rc-2
- Rebuild with gnome-desktop3-44~beta

* Thu Mar 16 2023 yuanhui <yuanhui@linux.alibaba.com> - 44~rc-1
- Update to 44~rc

* Wed Feb 15 2023 Funda Wang <fundawang@yeah.net> - 42.8-1
- New version 42.8

* Thu Dec 8 2022 Funda Wang <fundawang@yeah.net> - 42.7-1
- New version 42.7

* Mon Apr 18 2022 Yuanhong Peng <yummypeng@linux.alibaba.com> - 42.0-1
- Init package from upstream v42.0
